unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses RK_Method;

{$R *.dfm}

//Defining of functions (right parts os equations)     

function f0(VarArray:TVarsArray):extended;
begin
    Result:=4*VarArray[0]*VarArray[0]*VarArray[0];
end;

function f1(VarArray:TVarsArray):extended;
begin
   Result:=1;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TForm1.Button1Click(Sender: TObject);
var
  I: Integer;
  FunArray: TFunArray; // functions array
  First: Extended; // first point of undepended axis
  Last: Extended; // last point of undepended axis
  Steps: Integer; // amount of steps by undepended axis
  InitArray: TInitArray; // initial conditions array
  Res: TResArray; // results matrix (includes undepended variable)
begin
 // Creating of functions array:
  SetLength(FunArray,2);
  FunArray[0]:=f0;
  FunArray[1]:=f1;
  // Creating of interval and steps amount:
  First:=0;
  Last:=10;
  Steps:=10;
  // Creating of initial conditions:
  SetLength(InitArray,2);
  InitArray[0]:=0;
  InitArray[1]:=0;
  // Calling of Method and geting of result:
  Memo1.Lines.Clear;
  I:=Runge_Kutt(FunArray, First, Last, Steps, InitArray, Res);
  ShowMessage('Error Code = '+IntToStr(I));
  For I:=0 to Steps do
  Memo1.Lines.Add(floattostr(Res[0,I])+'   '+floattostr(Res[1,I])
  +'   '+floattostr(Res[2,I]));
end;

end.
